# testhand.py
# Steve Marschner (srm2) and Lillian Lee (ljl2)
# March 19, 2013
"""Testing module for the hand module."""

import cunittest2
import hand
import card

# Each entry in the following list is a list of a hand and the correct
# classifications for that hand.
# For each hand, the answers are in the order: [is_pair, is_2pair, is_3kind,
# is_straight, is_flush, is_full_house, is_4kind, is_straight_flush]
test_data_5cards = [  # P,2P,3K, S, F,FH,4K,SF
    ['2C 2D 3H 5C 6D', [1, 0, 0, 0, 0, 0, 0, 0]], # just 1 pair
    ['2C 2D 2H 5C 6D', [1, 0, 1, 0, 0, 0, 0, 0]], # 3 of a kind, also 1 pair
    ['2C 2D 5H 5C 6D', [1, 1, 0, 0, 0, 0, 0, 0]], # 2 pair, also 1 pair
    ['2C 2D 2H 3C 3D', [1, 1, 1, 0, 0, 1, 0, 0]], # full house, also 2p, 3k, and 1p
    ['2C 3D 4H 5C 6D', [0, 0, 0, 1, 0, 0, 0, 0]], # low straight
    ['6D 7D 8D 9D TD', [0, 0, 0, 1, 1, 0, 0, 1]], # 10-high straight flush
    ['9C 4D 4H 4C 4S', [1, 0, 1, 0, 0, 0, 1, 0]], # 4 of a kind, also 3k and 1p
    ['AS KS 4S 7S 5S', [0, 0, 0, 0, 1, 0, 0, 0]], # flush
    ['KS JH QC AC TH', [0, 0, 0, 1, 0, 0, 0, 0]], # high straight
    ['KS JS QS AS TS', [0, 0, 0, 1, 1, 0, 0, 1]], # straight flush is str and fl
]


if __name__ == '__main__':
    
    for testcase in test_data_5cards:
        h = hand.Hand(code=testcase[0])
        answers = testcase[1]
        cunittest2.assert_equals(answers[0], h.is_pair())
        cunittest2.assert_equals(answers[1], h.is_2pair())
        cunittest2.assert_equals(answers[2], h.is_3kind())
        cunittest2.assert_equals(answers[4], h.is_flush())
        cunittest2.assert_equals(answers[6], h.is_4kind())
        
    print "Hey, it works!"
    

























"""
   
# Each entry in the following list is a list of a hand and the correct
# classifications for that hand.
# For each hand, the answers are in the order: [is_pair, is_2pair, is_3kind,
# is_straight, is_flush, is_full_house, is_4kind, is_straight_flush]
test_data_5cards = [  # P,2P,3K, S, F,FH,4K,SF
    ['2C 2D 3H 5C 6D', [1, 0, 0, 0, 0, 0, 0, 0]], # just 1 pair
    ['2C 2D 2H 5C 6D', [1, 0, 1, 0, 0, 0, 0, 0]], # 3 of a kind, also 1 pair
    ['2C 2D 5H 5C 6D', [1, 1, 0, 0, 0, 0, 0, 0]], # 2 pair, also 1 pair
    ['2C 2D 2H 3C 3D', [1, 1, 1, 0, 0, 1, 0, 0]], # full house, also 2p, 3k, and 1p
    ['2C 3D 4H 5C 6D', [0, 0, 0, 1, 0, 0, 0, 0]], # low straight
    ['6D 7D 8D 9D TD', [0, 0, 0, 1, 1, 0, 0, 1]], # 10-high straight flush
    ['9C 4D 4H 4C 4S', [1, 0, 1, 0, 0, 0, 1, 0]], # 4 of a kind, also 3k and 1p
    ['AS KS 4S 7S 5S', [0, 0, 0, 0, 1, 0, 0, 0]], # flush
    ['KS JH QC AC TH', [0, 0, 0, 1, 0, 0, 0, 0]], # high straight
    ['KS JS QS AS TS', [0, 0, 0, 1, 1, 0, 0, 1]], # straight flush is str and fl
]

test_data_7cards = [        # P 2 3 S F H 4 SF
    ['2C 2D 3H KS TH 5C 6D', [1,0,0,0,0,0,0,0]], # just 1 pair
    ['AS KH 2C 2D 2H 5C 6D', [1,0,1,0,0,0,0,0]], # 3 of a kind, also 1 pair
    ['3H 2C 2D 6S 5H 5C 6D', [1,1,0,0,0,0,0,0]], # 2 pair, also 1 pair
    ['2C 4C 2D 2H 3C 6H 3D', [1,1,1,0,0,1,0,0]], # full house, also 2p, 3k, and 1p.
    ['AS 2C 3D 4H 5C 6D 7D', [0,0,0,1,0,0,0,0]], # low straight
    ['4H 5C 6D 7D 8D 9D TD', [0,0,0,1,1,0,0,1]], # 10-high straight flush
    ['9C 4D 4H 3C 5C 4C 4S', [1,0,1,0,0,0,1,0]], # 4 of a kind, also 3k and 1p
    ['9C 4D 4H 5S 5C 4C 4S', [1,1,1,0,0,1,1,0]], # 4 of a kind, also f_h, 3k, 2p and 1p
    ['AS KS 4S 6H KS KS KS', [1,0,1,0,1,0,1,0]], # 4 of a kind, also a flush
    ['KS JH QC 2S 6H AC TH', [0,0,0,1,0,0,0,0]], # high straight
    ['4H 8S KS JS QS AS TS', [0,0,0,1,1,0,0,1]], # straight flush is str and fl
#   ['4H 8S KS JH QS AS TS', [0,0,0,1,1,0,0,0]], # str and fl but not straight flush
]

"""
